"use strict";

exports.__esModule = true;
exports.default = exports.requestTimeout = exports.clearRequestTimeout = void 0;

var _raf = /*#__PURE__*/require("@essentials/raf");

/**
 * Copyright 2011, Joe Lambert.
 * Free to use under the MIT license.
 * http://www.opensource.org/licenses/mit-license.php
 **/
const clearRequestTimeout = handle => {
  (0, _raf.caf)(handle.v || -1);
};

exports.clearRequestTimeout = clearRequestTimeout;

const requestTimeout = (fn, ms) => {
  const start = (0, _raf.now)(),
        handle = {};

  const loop = () => {
    (0, _raf.now)() - start >= ms ? fn.call(null) : handle.v = (0, _raf.raf)(loop);
  };

  handle.v = (0, _raf.raf)(loop);
  return handle;
};

exports.requestTimeout = requestTimeout;
var _default = requestTimeout;
exports.default = _default;